#define _WIN32_WINNT 0x0601 
#include <XAudio2.h>
#include <cstdint>
#define _USE_MATH_DEFINES
#include <math.h>
#pragma comment(lib,"xaudio2.lib")
#pragma comment(lib,"ole32.lib")


//obt@ɂ傤ǎ܂g`쐬
void setWave(int16_t* waveformBuffer, int bufferLength, double amplitude){
	for (int i = 0; i < bufferLength; i++)
		waveformBuffer[i] = (int16_t)(amplitude * sin(2.0 * M_PI*(double)i / bufferLength));
}

int main(){
	IXAudio2*  pXAudio2 = NULL;
	IXAudio2MasteringVoice * pMasteringVoice = NULL;
	IXAudio2SubmixVoice * pSubmixVoice = NULL;
	IXAudio2SourceVoice * pSourceVoice = NULL;
	// COM
	CoInitializeEx(NULL, COINIT_MULTITHREADED);
	// قƂǂ̊֐ HRESULT^ ̕Ԃl̂Ŗ{`FbNׂ 
	XAudio2Create(&pXAudio2);
	//}X^{CX̍쐬
	pXAudio2->CreateMasteringVoice(&pMasteringVoice);
	//Tu~bNX{CX̍쐬
	// 1chimj,TvO[g44.1kHz
	// ڑw肵Ȃƃ}X^{CXɐڑ
	pXAudio2->CreateSubmixVoice(&pSubmixVoice, 1, 44100, 0, 0, 0, 0);
	//\[X{CX̐ݒ
	// g`̌`Ƃobt@TCYƂ̐ݒ
	// 1chimj,TvO[g44.1kHz,16bit
	WAVEFORMATEX waveFormat;
	waveFormat.wFormatTag = WAVE_FORMAT_PCM;
	waveFormat.nChannels = 1;
	waveFormat.nSamplesPerSec = 44100;
	waveFormat.nAvgBytesPerSec = 44100 * 2;
	waveFormat.nBlockAlign = 2;
	waveFormat.wBitsPerSample = 16;
	waveFormat.cbSize = 0;
	//ڑ
	XAUDIO2_SEND_DESCRIPTOR x[1];
	x[0].Flags = 0;
	x[0].pOutputVoice = pSubmixVoice;
	XAUDIO2_VOICE_SENDS y;
	y.SendCount = 1;
	y.pSends = x;
	//\[X{CX̍쐬
	pXAudio2->CreateSourceVoice(&pSourceVoice, &waveFormat, 0, XAUDIO2_MAX_FREQ_RATIO, NULL, &y);
	//g`̗
	const int bufferLength = 100;
	int16_t* waveformBuffer = new short[bufferLength];
	setWave(waveformBuffer, bufferLength, 1000);
	//obt@Ɋւݒ
	XAUDIO2_BUFFER buffer = { 0 };
	buffer.AudioBytes = bufferLength;
	buffer.pAudioData = (byte *)waveformBuffer;
	buffer.Flags = XAUDIO2_END_OF_STREAM;
	buffer.PlayBegin = 0;
	buffer.PlayLength = bufferLength;
	buffer.LoopBegin = 0;
	buffer.LoopLength = bufferLength;
	buffer.LoopCount = XAUDIO2_LOOP_INFINITE;
	//obt@ZbgčĐ
	pSourceVoice->SubmitSourceBuffer(&buffer);
	pSourceVoice->Start();
	//ĂƂ3b҂ 
	Sleep(3000);
	return 0;
}